97cf431ccad45241cc60e51f343607f2a33b521a
[deliverable/binutils-gdb.git] / configure
1 #!/bin/sh
2
3 # Configuration script
4 # Copyright (C) 1988, 1990, 1991, 1992 Free Software Foundation, Inc.
5
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
19
20 # Please email any bugs, comments, and/or additions to this file to:
21 # configure@cygnus.com
22
23 # This file was written by K. Richard Pixley.
24
25 #
26 # Shell script to create proper links to machine-dependent files in
27 # preparation for compilation.
28 #
29 # If configure succeeds, it leaves its status in config.status.
30 # If configure fails after disturbing the status quo,
31 # config.status is removed.
32 #
33
34 export PATH || (echo "OOPS, this isn't sh. Desperation time. I will feed myself to sh."; sh $0 $argv; kill $$)
35
36 remove=rm
37 hard_link=ln
38 symbolic_link='ln -s'
39
40 #for Test
41 #remove="echo rm"
42 #hard_link="echo ln"
43 #symbolic_link="echo ln -s"
44
45 # clear some things potentially inherited from environment.
46
47 Makefile=Makefile
48 Makefile_in=Makefile.in
49 arguments=$*
50 configdirs=
51 exec_prefix=
52 exec_prefixoption=
53 fatal=
54 floating_point=default
55 gas=default
56 host_alias=
57 host_makefile_frag=
58 next_host=
59 next_prefix=
60 next_site=
61 next_srcdir=
62 next_target=
63 next_tmpdir=
64 norecursion=
65 removing=
66 prefix=/usr/local
67 progname=
68 program_prefix=
69 program_prefix_option=
70 silent=
71 site=
72 site_option=
73 site_makefile_frag=
74 srcdir=
75 srctrigger=
76 subdirs=
77 target_alias=
78 target_makefile_frag=
79 undefinedargs=
80 verbose=
81 version="$Revision$"
82 x11=default
83
84 NO_EDIT="This file was generated automatically by configure. Do not edit."
85
86 ## this is a little touchy and won't always work, but...
87 ##
88 ## if the argv[0] starts with a slash then it is an absolute name that can (and
89 ## must) be used as is.
90 ##
91 ## otherwise, if argv[0] has no slash in it, we can assume that it is on the
92 ## path. Since PATH might include "." we also add `pwd` to the end of PATH.
93 ##
94
95 PWD=`pwd`
96 progname=$0
97
98 case "${progname}" in
99 /*) ;;
100 */*) ;;
101 *)
102 PATH=$PATH:${PWD} ; export PATH
103 ;;
104 esac
105
106 for arg in $*;
107 do
108 # handle things that might have args following as separate words
109 if [ -n "${next_prefix}" ] ; then prefix=${arg} ; prefixoption="-prefix=${prefix}" ; next_prefix=
110 elif [ -n "${next_exec_prefix}" ] ; then
111 exec_prefix=${arg}
112 exec_prefixoption="-exec_prefix=${exec_prefix}"
113 next_exec_prefix=
114 elif [ -n "${next_site}" ] ; then site=${arg} ; site_option=-site=${site} ; next_site=
115 # remove any possible trailing slash from srcdir. See note below.
116 elif [ -n "${next_srcdir}" ] ; then srcdir=`echo ${arg} | sed -e 's:/$::'` ; next_srcdir=
117 elif [ -n "${next_program_prefix}" ] ; then
118 program_prefix=${arg}
119 program_prefixoption="-program_prefix=${program_prefix}"
120 next_program_prefix=
121 elif [ -n "${next_target}" ] ; then
122 next_target=
123 case "${target_alias}" in
124 "")
125 target_alias="${arg}"
126 ;;
127 *)
128 echo '***' Can only configure for one target at a time. 1>&2
129 fatal=yes
130 ;;
131 esac
132 elif [ -n "${next_tmpdir}" ] ; then
133 next_tmpdir=
134 tmpdiroption="--tmpdir=${arg}"
135 TMPDIR=${arg}
136
137 else
138 case ${arg} in
139 -exec_prefix=* | --exec_prefix=* | --exec_prefi=* | --exec_pref=* | --exec_pre=* | --exec_pr=* | --exec_p=* | --exec_=* | --exec=* | --exe=* | --ex=* | --e=*)
140 exec_prefix=`echo ${arg} | sed 's/^[-a-z_]*=//'`
141 exec_prefixoption=${arg}
142 ;;
143 -exec_prefix | --exec_prefix | --exec_prefi | --exec_pref | --exec_pre | --exec_pr | --exec_p | --exec_ | --exec | --exe | --ex | --e)
144 next_exec_prefix=yes
145 ;;
146 -gas | --g*)
147 gas=yes
148 ;;
149 -help | --he*)
150 fatal=true
151 ;;
152 -host=* | --host=* | --hos=* | --ho=*)
153 case "${host_alias}" in
154 "")
155 host_alias="`echo ${arg} | sed 's/^[-a-z]*=//'`"
156 ;;
157 *)
158 echo '***' Can only configure for one host at a time. 1>&2
159 fatal=yes
160 ;;
161 esac
162 ;;
163 -nfp | --nf*)
164 floating_point=no
165 ;;
166 -norecursion | --no*)
167 norecursion=true
168 ;;
169 -prefix=* | --prefix=* | --prefi=* | --pref=* | --pre=*)
170 prefix=`echo ${arg} | sed 's/^[-a-z]*=//'`
171 prefixoption=${arg}
172 ;;
173 -prefix | --prefix | --prefi | --pref | --pre)
174 next_prefix=yes
175 ;;
176 -rm | --rm) removing=${arg} ;;
177 -program_prefix=* | --program_prefix=* | --program_prefi=* | --program_pref=* | --program_pre=* | --program_pr=* | --program_p=* | --program_=* | --program=* | --progra=* | --progr=* | --prog=* | --pro=*)
178 program_prefix=`echo ${arg} | sed 's/^[-a-z]*=//'`
179 program_prefixoption=${arg}
180 ;;
181 -program_prefix | --program_prefix | --program_prefi | --program_pref | --program_pre | --program_pr | --program_p | --program_ | --program | --progra | --progr | --prog | --pro)
182 next_program_prefix=yes
183 ;;
184 -s | -silent | --silent | --silen | --sile | --sil)
185 silent=true
186 arguments=`echo ${arguments} | sed "s:${arg}::"`
187 ;;
188 -site=* | --site=* | --sit=* | --si=*)
189 site_option=${arg}
190 site=`echo ${arg} | sed 's/^[-a-z]*=//'`
191 ;;
192 -site | --site | --sit)
193 next_site=yes
194 ;;
195 # remove trailing slashes. Otherwise, when the file name gets
196 # bolted into an object file as debug info, it has two slashes in
197 # it. Ordinarily this is ok, but emacs takes double slash to
198 # mean "forget the first part".
199 -srcdir=* | --srcdir=* | --srcdi=* | --srcd=* | --src=* | --sr=*)
200 srcdir=`echo ${arg} | sed 's/^[-a-z]*=//' | sed -e 's:/$::'`
201 ;;
202 -srcdir | --srcdir | --srcdi | --srcd | --src | --sr)
203 next_srcdir=yes
204 ;;
205 -target=* | --target=* | --targe=* | --targ=* | --tar=* | --ta=*)
206 case "${target_alias}" in
207 "") target_alias="`echo ${arg} | sed 's/^[-a-z]*=//'`" ;;
208 *)
209 echo '***' Can only configure for one target at a time. 1>&2
210 fatal=yes
211 ;;
212 esac
213 ;;
214 -target | --target | --targe | --targ | --tar | --ta)
215 next_target=yes
216 ;;
217 -tmpdir=* | --tmpdir=* | --tmpdi=* | --tmpd=* | --tmp=* | --tm=*)
218 tmpdiroption=${arg}
219 TMPDIR=`echo ${arg} | sed 's/^[-a-z]*=//'`
220 ;;
221 -tmpdir | --tmpdir | --tmpdi | --tmpd | --tmp | --tm)
222 next_tmpdir=yes
223 ;;
224 -v | -verbose | --v)
225 verbose=${arg}
226 ;;
227 -version | -V | --version | --V)
228 echo "This is Cygnus Configure version" `echo ${version} | sed 's/[ $:]//g'`
229 exit 0
230 ;;
231 -x | --x) ;;
232 -* | --*)
233 (echo ;
234 echo "Unrecognized option: \"${arg}\"". ;
235 echo) 1>&2
236 fatal=true
237 ;;
238 *)
239 case "${undefs}" in
240 "")
241 undefs="${arg}"
242 ;;
243 *)
244 echo '***' Can only configure for one host and one target at a time. 1>&2
245 fatal=yes
246 ;;
247 esac
248 ;;
249 esac
250 fi
251 done
252
253 # process host and target
254 case "${fatal}" in
255 "")
256 # # Complain if an arg is missing
257 # if [ -z "${host_alias}" ] ; then
258 # (echo ;
259 # echo "configure: No HOST specified." ;
260 # echo) 1>&2
261 # fatal=true
262 # fi
263
264 ### This is a bit twisted.
265 ### * if all three are specified, this is an error.
266 ### * if we have neither hosts, nor unadorned args, this is an error.
267 ### * if no hosts are specified, then the unadorned args are hosts, but if
268 ### there were none, this is an error.
269 ### * if no targets are specified, then the unadorned args are targets, but if
270 ### there were no unadorned args, then the hosts are also targets.
271
272 if [ -n "${host_alias}" -a -n "${target_alias}" -a -n "${undefs}" ] ; then
273 echo '***' Can only configure for one host and one target at a time. 1>&2
274 fatal=yes
275 elif [ -z "${host_alias}" -a -z "${undefs}" ] ; then
276 echo '***' You must tell me for which host you want to configure. 1>&2
277 fatal=yes
278 else
279 case "${host_alias}" in
280 "") host_alias=${undefs} ;;
281 *) ;;
282 esac
283
284 case "${target_alias}" in
285 "")
286 case "${undefs}" in
287 "") target_alias=${host_alias} ;;
288 *) target_alias=${undefs} ;;
289 esac
290 ;;
291 *) ;;
292 esac
293 fi
294 ;;
295 *) ;;
296 esac
297
298 if [ -n "${fatal}" -o "${host_alias}" = "help" ] ; then
299 (echo "Usage: configure HOST" ;
300 echo ;
301 echo "Options: [defaults in brackets]" ;
302 echo " -exec_prefix=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
303 echo " -gas configure the compilers for use with gas. [native as]" ;
304 echo " -help print this message. [normal config]" ;
305 echo " -lang=LANG configure to build LANG. [gcc]" ;
306 echo " -nfp configure the compilers default to soft floating point. [hard float]" ;
307 echo " -norecursion configure this directory only. [recurse]" ;
308 echo " -prefix=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
309 echo " -program_prefix=FOO install programs with FOO prepended to their names. [ \"\" ]" ;
310 echo " -site=SITE configure with site specific makefile for SITE" ;
311 echo " -srcdir=DIR find the sources in DIR. [\".\" or \"..\"]" ;
312 echo " -target=TARGET configure for TARGET. [TARGET = HOST]" ;
313 echo " -tmpdir=TMPDIR create temporary files in TMPDIR. [ TMPDIR = \"/tmp\" ]" ;
314 echo ;
315 echo "Where HOST and TARGET are something like \"vax\", \"sun3\", \"encore\", etc." ;
316 ) 1>&2
317
318 if [ -r config.status ] ; then
319 cat config.status
320 fi
321
322 exit 1
323 fi
324
325 configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
326
327 # this is a hack. sun4 must always be a valid host alias or this will fail.
328 if ${configsub} sun4 >/dev/null 2>&1 ; then
329 true
330 else
331 echo '***' cannot find config.sub. 1>&2
332 exit 1
333 fi
334
335 case "${srcdir}" in
336 "")
337 if [ -r configure.in ] ; then
338 srcdir=.
339 else
340 if [ -r ${progname}.in ] ; then
341 srcdir=`echo ${progname} | sed 's:/configure$::'`
342 else
343 echo '***' "Can't find configure.in. Try using -srcdir=some_dir" 1>&2
344 exit 1
345 fi
346 fi
347 ;;
348 *) ;;
349 esac
350
351 ### warn about some conflicting configurations.
352
353 case "${srcdir}" in
354 ".") ;;
355 *)
356 if [ -f ${srcdir}/config.status ] ; then
357 echo '***' Cannot configure here in \"${PWD}\" when \"${srcdir}\" is currently configured. 1>&2
358 exit 1
359 fi
360 esac
361
362 # default exec_prefix
363 case "${exec_prefix}" in
364 "") exec_prefix="\$(prefix)" ;;
365 *) ;;
366 esac
367
368 ### break up ${srcdir}/configure.in.
369 case "`grep '^# per\-host:' ${srcdir}/configure.in`" in
370 "")
371 echo '***' ${srcdir}/configure.in has no "per-host:" line. 1>&2
372 exit 1
373 ;;
374 *) ;;
375 esac
376
377 case "`grep '^# per\-target:' ${srcdir}/configure.in`" in
378 "")
379 echo '***' ${srcdir}/configure.in has no "per-target:" line. 1>&2
380 exit 1
381 ;;
382 *) ;;
383 esac
384
385 case "${TMPDIR}" in
386 "") TMPDIR=/tmp ; export TMPDIR ;;
387 *) ;;
388 esac
389
390 # keep this filename short for &%*%$*# 14 char file names
391 tmpfile=${TMPDIR}/cONf$$
392 trap "rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos" 0
393
394 # split ${srcdir}/configure.in into common, per-host, per-target,
395 # and post-target parts. Post-target is optional.
396 sed -e '/^# per\-host:/,$d' ${srcdir}/configure.in > ${tmpfile}.com
397 sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' ${srcdir}/configure.in > ${tmpfile}.hst
398 if grep '^# post-target:' ${srcdir}/configure.in >/dev/null ; then
399 sed -e '1,/^# per\-target:/d' -e '/^# post\-target:/,$d' ${srcdir}/configure.in > ${tmpfile}.tgt
400 sed -e '1,/^# post\-target:/d' ${srcdir}/configure.in > ${tmpfile}.pos
401 else
402 sed -e '1,/^# per\-target:/d' ${srcdir}/configure.in > ${tmpfile}.tgt
403 echo >${tmpfile}.pos
404 fi
405
406 ### do common part of configure.in
407
408 . ${tmpfile}.com
409
410 # some sanity checks on configure.in
411 case "${srctrigger}" in
412 "")
413 echo '***' srctrigger not set in ${PWD}/configure.in. 1>&2
414 exit 1
415 ;;
416 *) ;;
417 esac
418
419 result=`${configsub} ${host_alias}`
420 host_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
421 host_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
422 host_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
423 host=${host_cpu}-${host_vendor}-${host_os}
424
425 . ${tmpfile}.hst
426
427 result=`${configsub} ${target_alias}`
428 target_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
429 target_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
430 target_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
431 target=${target_cpu}-${target_vendor}-${target_os}
432
433 . ${tmpfile}.tgt
434
435 # Find the source files, if location was not specified.
436 case "${srcdir}" in
437 "")
438 srcdirdefaulted=1
439 srcdir=.
440 if [ ! -r ${srctrigger} ] ; then
441 srcdir=..
442 fi
443 ;;
444 *) ;;
445 esac
446
447 if [ ! -r ${srcdir}/${srctrigger} ] ; then
448 case "${srcdirdefaulted}" in
449 "") echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/${srcdir}" 1>&2 ;;
450 *) echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/. or ${PWD}/.." 1>&2 ;;
451 esac
452
453 echo '***' \(At least ${srctrigger} is missing.\) 1>&2
454 exit 1
455 fi
456
457 for subdir in . ${subdirs} ; do
458
459 # ${subdir} is relative path from . to the directory we're currently
460 # configuring.
461 # ${invsubdir} is inverse of ${subdir), *with* trailing /, if needed.
462 invsubdir=`echo ${subdir}/ | sed -e 's|\./||g' -e 's|[^/]*/|../|g'`
463
464 ### figure out what to do with srcdir
465 case "${srcdir}" in
466 ".") # no -srcdir option. We're building in place.
467 makesrcdir=. ;;
468 /*) # absolute path
469 makesrcdir=`echo ${srcdir}/${subdir} | sed -e 's|/\.$||'`
470 ;;
471 *) # otherwise relative
472 case "${subdir}" in
473 .) makesrcdir=${srcdir} ;;
474 *) makesrcdir=../${srcdir}/${subdir} ;;
475 esac
476 ;;
477 esac
478
479 if [ "${subdir}/" != "./" ] ; then
480 Makefile=${subdir}/Makefile
481 fi
482
483 if [ ! -d ${subdir} ] ; then
484 mkdir ${subdir}
485 fi
486
487 case "${removing}" in
488 "")
489 if [ -n "${verbose}" -o -z "${silent}" ] ; then
490 echo Building in ${subdir}
491 fi
492 # FIXME Should this be done recursively ??? (Useful for e.g. gdbtest)
493 # Set up the list of links to be made.
494 # ${links} is the list of link names, and ${files} is the list of names to link to.
495
496 # Make the links.
497 configlinks="${links}"
498 while [ -n "${files}" ] ; do
499 # set file to car of files, files to cdr of files
500 set ${files}; file=$1; shift; files=$*
501 set ${links}; link=$1; shift; links=$*
502
503 if [ ! -r ${srcdir}/${file} ] ; then
504 echo '***' "${progname}: cannot create a link \"${link}\"," 1>&2
505 echo '***' "since the file \"${file}\" does not exist." 1>&2
506 exit 1
507 fi
508
509 ${remove} -f ${link}
510 rm -f config.status
511 # Make a symlink if possible, otherwise try a hard link
512 ${symbolic_link} ${srcdir}/${file} ${link} 2>/dev/null || ${hard_link} ${srcdir}/${file} ${link}
513
514 if [ ! -r ${link} ] ; then
515 echo '***' "${progname}: unable to link \"${link}\" to \"${srcdir}/${file}\"." 1>&2
516 exit 1
517 fi
518
519 case "${verbose}" in
520 "") ;;
521 *) echo "Linked \"${link}\" to \"${srcdir}/${file}\"." ;;
522 esac
523 done
524
525 # Create a .gdbinit file which runs the one in srcdir
526 # and tells GDB to look there for source files.
527
528 if [ -r ${srcdir}/${subdir}/.gdbinit ] ; then
529 case ${srcdir} in
530 .)
531 ;;
532 *) cat > ${subdir}/.gdbinit <<EOF
533 # ${NO_EDIT}
534 dir .
535 dir ${makesrcdir}
536 source ${makesrcdir}/.gdbinit
537 EOF
538 ;;
539 esac
540 fi
541
542 # Install a makefile, and make it set VPATH
543 # if necessary so that the sources are found.
544 # Also change its value of srcdir.
545 # NOTE: Makefile generation constitutes the majority of the time in configure. Hence, this section has
546 # been somewhat optimized and is perhaps a bit twisty.
547
548 # code is order so as to try to sed the smallest input files we know.
549
550 # the three makefile fragments MUST end up in the resulting Makefile in this order: target, host, and site.
551 # so do these separately because I don't trust the order of sed -e expressions.
552
553 # Conditionalize for this site from "Makefile.in" (or whatever it's called) into Makefile.tem
554 case "${site}" in
555 "") cp ${srcdir}/${subdir}/${Makefile_in} ${subdir}/Makefile.tem ;;
556 *)
557 site_makefile_frag=${srcdir}/config/ms-${site}
558
559 if [ -f ${site_makefile_frag} ] ; then
560 sed -e "/^####/ r ${site_makefile_frag}" ${srcdir}/${subdir}/${Makefile_in} \
561 > ${subdir}/Makefile.tem
562 else
563 cp ${srcdir}/${subdir}/${Makefile_in} ${subdir}/Makefile.tem
564 site_makefile_frag=
565 fi
566 ;;
567 esac
568 # working copy now in ${subdir}/Makefile.tem
569
570 # Conditionalize the makefile for this host.
571 case "${host_makefile_frag}" in
572 "") mv ${subdir}/Makefile.tem ${Makefile} ;;
573 *)
574 if [ ! -f ${host_makefile_frag} ] ; then
575 host_makefile_frag=${srcdir}/${host_makefile_frag}
576 fi
577 if [ -f ${host_makefile_frag} ] ; then
578 sed -e "/^####/ r ${host_makefile_frag}" ${subdir}/Makefile.tem > ${Makefile}
579 else
580 echo '***' Expected host makefile fragment \"${host_makefile_frag}\" 1>&2
581 echo '***' is missing in ${PWD}. 1>&2
582 mv ${subdir}/Makefile.tem ${Makefile}
583 fi
584 esac
585 # working copy now in ${Makefile}
586
587 # Conditionalize the makefile for this target.
588 case "${target_makefile_frag}" in
589 "") mv ${Makefile} ${subdir}/Makefile.tem ;;
590 *)
591 target_makefile_frag=${srcdir}/${target_makefile_frag}
592 if [ -f ${target_makefile_frag} ] ; then
593 sed -e "/^####/ r ${target_makefile_frag}" ${Makefile} > ${subdir}/Makefile.tem
594 else
595 mv ${Makefile} ${subdir}/Makefile.tem
596 target_makefile_frag=
597 fi
598 ;;
599 esac
600 # real copy now in ${subdir}/Makefile.tem
601
602 # prepend warning about editting, and a bunch of variables.
603 cat > ${Makefile} <<EOF
604 # ${NO_EDIT}
605 VPATH = ${makesrcdir}
606 links = ${configlinks}
607 host_alias = ${host_alias}
608 host_cpu = ${host_cpu}
609 host_vendor = ${host_vendor}
610 host_os = ${host_os}
611 target_alias = ${target_alias}
612 target_cpu = ${target_cpu}
613 target_vendor = ${target_vendor}
614 target_os = ${target_os}
615 EOF
616 if [ "${target_makefile_frag}" != "" ] ; then
617 echo target_makefile_frag = ${invsubdir}${target_makefile_frag} >>${Makefile}
618 fi
619 if [ "${host_makefile_frag}" != "" ] ; then
620 echo host_makefile_frag = ${invsubdir}${host_makefile_frag} >>${Makefile}
621 fi
622 if [ "${site_makefile_frag}" != "" ] ; then
623 echo site_makefile_frag = ${invsubdir}${site_makefile_frag} >>${Makefile}
624 fi
625
626 # fixme: this shouldn't be in configure.
627 # Define macro CROSS_COMPILE in compilation if this is a cross-compiler.
628 case "${host_alias}" in
629 "${target_alias}")
630 tooldir='$(libdir)'
631 echo "ALL=all.internal" >> ${Makefile}
632 ;;
633 *)
634 echo "CROSS=-DCROSS_COMPILE" >> ${Makefile}
635 echo "ALL=all.cross" >> ${Makefile}
636 case "${program_prefix}" in
637 "") program_prefix=${target_alias}- ;;
638 *) ;;
639 esac
640
641 tooldir="\$(libdir)/${target_alias}"
642 ;;
643 esac
644
645 # reset prefix, exec_prefix, srcdir, SUBDIRS, NONSUBDIRS,
646 # remove any form feeds.
647 if [ -z "${subdirs}" ]; then
648 sed -e "s:^SUBDIRS[ ]*=.*$:SUBDIRS = ${configdirs}:" \
649 -e "s:^NONSUBDIRS[ ]*=.*$:NONSUBDIRS = ${noconfigdirs}:" \
650 ${subdir}/Makefile.tem > ${subdir}/Makefile.tem2
651 mv ${subdir}/Makefile.tem2 ${subdir}/Makefile.tem
652 fi
653 sed -e "s:^prefix[ ]*=.*$:prefix = ${prefix}:" \
654 -e "s:^exec_prefix[ ]*=.*$:exec_prefix = ${exec_prefix}:" \
655 -e "s:^srcdir[ ]*=.*$:srcdir = ${makesrcdir}:" \
656 -e "s/\f//" \
657 -e "s:^program_prefix[ ]*=.*$:program_prefix = ${program_prefix}:" \
658 -e "s:^tooldir[ ]*=.*$:tooldir = ${tooldir}:" \
659 ${subdir}/Makefile.tem >> ${Makefile}
660 # final copy now in ${Makefile}
661
662 rm ${subdir}/Makefile.tem
663
664 if [ -n "${verbose}" -o -z "${silent}" ] ; then
665 case "${host_makefile_frag}" in
666 "") using= ;;
667 *) using="and \"${host_makefile_frag}\"" ;;
668 esac
669
670 case "${target_makefile_frag}" in
671 "") ;;
672 *) using="${using} and \"${target_makefile_frag}\"" ;;
673 esac
674
675 case "${site_makefile_frag}" in
676 "") ;;
677 *) using="${using} and \"${site_makefile_frag}\"" ;;
678 esac
679
680 echo "Created \"${Makefile}\" in" ${PWD} `echo "${using}" | sed 's/and/using/'`
681 fi
682
683 . ${tmpfile}.pos
684
685 # describe the chosen configuration in config.status.
686 # Make that file a shellscript which will reestablish
687 # the same configuration. Used in Makefiles to rebuild
688 # Makefiles.
689
690 case "${norecursion}" in
691 "") arguments="${arguments} -norecursion" ;;
692 *) ;;
693 esac
694
695 if [ ${subdir} = . ] ; then
696 echo "#!/bin/sh
697 # ${NO_EDIT}
698 # ${PWD} was configured as follows:
699 ${progname}" ${arguments} "
700 # ${using}" > ${subdir}/config.status
701 else
702 echo "#!/bin/sh
703 # ${NO_EDIT}
704 # ${PWD}/${subdir} was configured as follows:
705 cd ${invsubdir}
706 ${progname}" ${arguments} "
707 # ${using}" > ${subdir}/config.status
708 fi
709 chmod a+x ${subdir}/config.status
710 ;;
711
712 *) rm -f ${Makefile} ${subdir}/config.status ${links} ;;
713 esac
714 done
715
716 # If there are subdirectories, then recur.
717 if [ -z "${norecursion}" -a -n "${configdirs}" ] ; then
718 for configdir in ${configdirs} ; do
719 case "${verbose}" in
720 "") ;;
721 *) echo Configuring ${configdir}... ;;
722 esac
723
724 if [ -d ${srcdir}/${configdir} ] ; then
725 case "${srcdir}" in
726 ".") ;;
727 *)
728 if [ ! -d ./${configdir} ] ; then
729 mkdir ./${configdir}
730 fi
731 ;;
732 esac
733
734 POPDIR=${PWD}
735 cd ${configdir}
736
737 ### figure out what to do with srcdir
738 case "${srcdir}" in
739 ".") newsrcdir=${srcdir} ;; # no -srcdir option. We're building in place.
740 /*) # absolute path
741 newsrcdir=${srcdir}/${configdir}
742 srcdiroption="-srcdir=${newsrcdir}"
743 ;;
744 *) # otherwise relative
745 newsrcdir=../${srcdir}/${configdir}
746 srcdiroption="-srcdir=${newsrcdir}"
747 ;;
748 esac
749
750 ### check for guested configure, otherwise fix possibly relative progname
751 if [ -f ${newsrcdir}/configure ] ; then
752 recprog=${newsrcdir}/configure
753 else
754 case "${progname}" in
755 /*) recprog=${progname} ;;
756 *) recprog=../${progname} ;;
757 esac
758 fi
759
760 ### The recursion line is here.
761 if ${recprog} -s ${host_alias} -target=${target_alias} \
762 ${verbose} ${prefixoption} ${tmpdiroption} ${exec_prefixoption} \
763 ${srcdiroption} ${program_prefixoption} ${site_option} ${removing} ; then
764 true
765 else
766 exit 1
767 fi
768
769 cd ${POPDIR}
770 else
771 case "${verbose}" in
772 "") ;;
773 *) echo Warning: source directory \"${srcdir}/${configdir}\" is missing. ;;
774 esac
775 fi
776 done
777 fi
778
779 ### clean up.
780
781 # trap cmd above handles this now:
782 #rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos
783
784 exit 0
785
786 #
787 # Local Variables:
788 # fill-column: 131
789 # End:
790 #
791
792 # end of configure
This page took 0.046497 seconds and 4 git commands to generate.